import subprocess
import sys
from pathlib import Path
import os
from time import sleep
from threading import Thread
import threading
import re

file="test5_1.txt"

max_threads=int(input("max threads: "))
print(type(max_threads))
i=0
output_folder_name ="/bulk_convert_out/"


#droppedFile= ['test.mkv0out.mkv', "test.mkv1out.mkv","test.mkv2out.mkv","test.mkv3out.mkv","test.mkv4out.mkv","test.mkv5out.mkv"]
#get path of script location and remove the tail


#get path of script location and remove the tail
head_tail = os.path.split(sys.argv[0])
output_path = head_tail[0]

#skip first part of sys.argv since it points to script location
#arguments = sys.argv[1:]
#arguments = droppedFile

#check if output folder exists, otherwise create it
isExist = os.path.exists(output_path+output_folder_name)
if not isExist:
    os.makedirs(output_path+output_folder_name)

def read_file(path=""):
    with open(file,'r+') as f: 
        path = f.readlines(1)
        all = f.readlines()
        f.seek(0)
        f.truncate()
        f.writelines(all)
        return path


class CustomThread(Thread):
    # constructor
    def __init__(self, input_file=""):

        # execute the base constructor
        Thread.__init__(self)
        # set a default value
        self.input_file = input_file


    def run(self):

        #sleep(1)
        global i
        global finished_count
        file = str(input_file[0])
        file = file.rstrip("\n")
        basename=os.path.basename(file)
        print(file)
        args = 'ffmpeg.exe -i "{file}" -fps_mode passthrough -map 0:t? -map 0:v:0 -c:v libx265 -preset slow -crf 15.4 -x265-params "no-sao=1:bframes=8:psy-rd=2:psy-rdoq=1.5:aq-mode=3:ref=6:deblock=-1,-1" -vf crop=1920:816:0:132 -pix_fmt yuv420p10le -map 0:a? -c:a libopus -ac 6 -b:a 576k -map 0:s? -c:s copy -f matroska "{output_path}{output_folder_name}{basename}"'.format(file=file, output_path=output_path, output_folder_name=output_folder_name,  basename=basename)
        print(args)
        results = subprocess.Popen(args, creationflags=0x00004000, stdout=subprocess.PIPE)
        #streeamdata = results.communicate()[0]
        data = results.wait()


        if data == 0:
            i=i-1


      
filesize = os.path.getsize(file)
while filesize != 0:
    if i < max_threads:
        global self
        filesize = os.path.getsize(file)
        if filesize != 0:
            input_file = read_file()
            print(input_file)
            t1 = CustomThread(input_file)
            t1.start()
        if filesize == 0:
                while bool(threading.active_count() > 1):
                        print("Finished","out of", )
                        sleep(1)
                        filesize = os.path.getsize(file)
                        if filesize != 0:
                            print("breaking while")
                            break
                filesize = os.path.getsize(file)
                if filesize != 0:
                    print("breaking if")
                    continue
                t1.join()
                print("Completed","out of", "inputs Successfully")
                input("waiting")
                exit()
        
        print("incrementing i in loop")
        i=i+1

    else:
        print("Finished ","out of ")
        sleep(1)
        print("continuing ")
